]>
Commit | Line | Data |
---|---|---|
b5850466 J |
1 | #!/bin/sh |
2 | ### BEGIN INIT INFO | |
21ce819a J |
3 | # Provides: hmland |
4 | # Required-Start: $network $local_fs $remote_fs | |
5 | # Required-Stop: $remote_fs | |
b5850466 J |
6 | # Default-Start: 2 3 4 5 |
7 | # Default-Stop: 0 1 6 | |
8 | # Short-Description: <Enter a short description of the sortware> | |
9 | # Description: <Enter a long description of the software> | |
10 | # <...> | |
11 | # <...> | |
12 | ### END INIT INFO | |
13 | ||
14 | # Author: root <jsurf@gmx.de> | |
15 | ||
16 | # PATH should only include /usr/* if it runs after the mountnfs.sh script | |
17 | PATH=/sbin:/usr/sbin:/bin:/usr/bin | |
21ce819a J |
18 | DESC="Homematic LAN Adapter service" # Introduce a short description here |
19 | NAME=hmland # Introduce the short server's name here | |
20 | DAEMON=/opt/hm/hmcfgusb/$NAME # Introduce the server's location here | |
53dbc699 | 21 | DAEMON_ARGS="-d -P" # Arguments to run the daemon with |
b5850466 J |
22 | PIDFILE=/var/run/$NAME.pid |
23 | SCRIPTNAME=/etc/init.d/$NAME | |
24 | ||
25 | # Exit if the package is not installed | |
26 | [ -x $DAEMON ] || exit 0 | |
27 | ||
53dbc699 MG |
28 | HMLAND_LOGGING="no" |
29 | HMLAND_PORT="1000" | |
30 | HMLAND_ENABLED="0" | |
31 | ||
b5850466 J |
32 | # Read configuration variable file if it is present |
33 | [ -r /etc/default/$NAME ] && . /etc/default/$NAME | |
34 | ||
53dbc699 MG |
35 | test "$HMLAND_ENABLED" != "0" || exit 0 |
36 | ||
37 | DAEMON_ARGS="$DAEMON_ARGS -p $HMLAND_PORT $HMLAND_OPTS" | |
38 | ||
39 | if [ "$HMLAND_LOGGING" = "yes" ]; then | |
40 | DAEMON_ARGS="$DAEMON_ARGS -L /var/log/hmland.log" | |
41 | fi | |
42 | ||
b5850466 J |
43 | # Load the VERBOSE setting and other rcS variables |
44 | . /lib/init/vars.sh | |
45 | ||
46 | # Define LSB log_* functions. | |
47 | # Depend on lsb-base (>= 3.0-6) to ensure that this file is present. | |
48 | . /lib/lsb/init-functions | |
49 | ||
50 | # | |
51 | # Function that starts the daemon/service | |
52 | # | |
53 | do_start() | |
54 | { | |
55 | # Return | |
56 | # 0 if daemon has been started | |
57 | # 1 if daemon was already running | |
58 | # 2 if daemon could not be started | |
59 | start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \ | |
60 | || return 1 | |
61 | start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \ | |
62 | $DAEMON_ARGS \ | |
63 | || return 2 | |
64 | # Add code here, if necessary, that waits for the process to be ready | |
65 | # to handle requests from services started subsequently which depend | |
66 | # on this one. As a last resort, sleep for some time. | |
67 | } | |
68 | ||
69 | # | |
70 | # Function that stops the daemon/service | |
71 | # | |
72 | do_stop() | |
73 | { | |
74 | # Return | |
75 | # 0 if daemon has been stopped | |
76 | # 1 if daemon was already stopped | |
77 | # 2 if daemon could not be stopped | |
78 | # other if a failure occurred | |
79 | start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $NAME | |
80 | RETVAL="$?" | |
81 | [ "$RETVAL" = 2 ] && return 2 | |
82 | # Wait for children to finish too if this is a daemon that forks | |
83 | # and if the daemon is only ever run from this initscript. | |
84 | # If the above conditions are not satisfied then add some other code | |
85 | # that waits for the process to drop all resources that could be | |
86 | # needed by services started subsequently. A last resort is to | |
87 | # sleep for some time. | |
88 | start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON | |
89 | [ "$?" = 2 ] && return 2 | |
90 | # Many daemons don't delete their pidfiles when they exit. | |
91 | rm -f $PIDFILE | |
92 | return "$RETVAL" | |
93 | } | |
94 | ||
95 | # | |
96 | # Function that sends a SIGHUP to the daemon/service | |
97 | # | |
98 | do_reload() { | |
99 | # | |
100 | # If the daemon can reload its configuration without | |
101 | # restarting (for example, when it is sent a SIGHUP), | |
102 | # then implement that here. | |
103 | # | |
104 | start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME | |
105 | return 0 | |
106 | } | |
107 | ||
108 | case "$1" in | |
109 | start) | |
110 | [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC " "$NAME" | |
111 | do_start | |
112 | case "$?" in | |
113 | 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; | |
114 | 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; | |
115 | esac | |
116 | ;; | |
117 | stop) | |
118 | [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$NAME" | |
119 | do_stop | |
120 | case "$?" in | |
121 | 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;; | |
122 | 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;; | |
123 | esac | |
124 | ;; | |
125 | status) | |
126 | status_of_proc "$DAEMON" "$NAME" && exit 0 || exit $? | |
127 | ;; | |
128 | #reload|force-reload) | |
129 | # | |
130 | # If do_reload() is not implemented then leave this commented out | |
131 | # and leave 'force-reload' as an alias for 'restart'. | |
132 | # | |
133 | #log_daemon_msg "Reloading $DESC" "$NAME" | |
134 | #do_reload | |
135 | #log_end_msg $? | |
136 | #;; | |
137 | restart|force-reload) | |
138 | # | |
139 | # If the "reload" option is implemented then remove the | |
140 | # 'force-reload' alias | |
141 | # | |
142 | log_daemon_msg "Restarting $DESC" "$NAME" | |
143 | do_stop | |
144 | case "$?" in | |
145 | 0|1) | |
146 | do_start | |
147 | case "$?" in | |
148 | 0) log_end_msg 0 ;; | |
149 | 1) log_end_msg 1 ;; # Old process is still running | |
150 | *) log_end_msg 1 ;; # Failed to start | |
151 | esac | |
152 | ;; | |
153 | *) | |
154 | # Failed to stop | |
155 | log_end_msg 1 | |
156 | ;; | |
157 | esac | |
158 | ;; | |
159 | *) | |
160 | #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2 | |
161 | echo "Usage: $SCRIPTNAME {start|stop|status|restart|force-reload}" >&2 | |
162 | exit 3 | |
163 | ;; | |
164 | esac | |
165 | ||
166 | : |